def palindrome(string):
    # Base Case
    if len(string) < 2:  # 1 character or empty string
        return True

    # Recursive case
    first_last = string[0] == string[-1]  # first & last char match?
    middle = string[1:-1]
    middle_good = palindrome(middle)  # middle is a palindrome
    return first_last and middle_good


def mystery(n):
    # Base Case
    if n == 1:
        return 1

    # Recursive Case
    return n + mystery(n-1)


def fib(n):
    # Base case
    if n < 2:
        return 1  # fib(0) = fib(1) = 1

    # Recursive case
    return fib(n-1) + fib(n-2)


def main():
    print(palindrome("abba"))
    print(palindrome("abcba"))
    print(palindrome("abca"))

    print(mystery(3))
    print(mystery(5))

    print(fib(3))
    print(fib(47))


if __name__ == "__main__":
    main()